
local pcUF = LibStub("AceAddon-3.0"):NewAddon("Peacock","AceConsole-3.0")
local mh4 = LibStub:GetLibrary("LibMobHealth-4.0")
-- for debugging
--_G["pcUF"] = pcUF

---------------------------------------------------------------------------
---------Edit the following vars to change things around a bit-------------
---------------------------------------------------------------------------
local size = 100 -- set the scale of the UI
local yoffset = -200 -- y location of the frames
local xoffset = -200 -- xlocation of the player frame (target frame is mirrored across the middle of the frame)
local steps = 2 -- resolution of the shaped unitframes (how rough the rounds are 2 seams to be a nice value)
local aurasize = 12 -- size of the buff/debuffs

local tsort = table.sort
local tremove = table.remove

local CenterRotation

local powercolor = {
		[0] = { r = 48/255, g = 113/255, b = 191/255}, -- Mana
		[1] = { r = 226/255, g = 45/255, b = 75/255}, -- Rage
		[2] = { r = 255/255, g = 178/255, b = 0}, -- Focus
		[3] = { r = 1, g = 1, b = 34/255}, -- Energy
		[4] = { r = 0, g = 1, b = 1} -- Happiness
	}

local DebuffTypeColor = DebuffTypeColor
local DebuffColor = {}
local color = {}

local units = {}
units.pettarget = true
units.player = true
units.pet = true
units.targettarget = true
units.target = true
units.focus = true

local font = "Fonts\\FRIZQT__.TTF"
local scanner = {}
local unitHealth = {}
local unitPower = {}
local unitName = {}
local unitLevel = {}
local unitLevelraw = {}
for k in pairs(units) do
    scanner[k] = '' 
    unitHealth[k] = 0
    unitPower[k] = 0
    unitName[k] = ''
    unitLevel[k] = ''
    unitLevelraw[k] = ''
end

-- Buff Tables
local TableOfBuffs = {}
local TableOfBuffsTime = {}
local BuffsubTableNotInUse = {}
setmetatable(BuffsubTableNotInUse, {__mode = "kv"})

-- DeBuff Tables
local TableOfDeBuffs = {}
local TableOfDeBuffsTime = {}
local DeBuffsubTableNotInUse = {}
setmetatable(DeBuffsubTableNotInUse, {__mode = "kv"})

local options = {
	type='group',
	icon = "",
	name = "Test Bed",
	plugins = {},
	args = {
        auratest={
            name="Aura Stress Test",
            desc="Aura Stress Test (call aura 1000 times)",
            type="execute",
            func=function()
                UpdateAddOnCPUUsage()
                UpdateAddOnMemoryUsage()
                local currentCPU = GetAddOnCPUUsage("Peacock")
                local currentmem = GetAddOnMemoryUsage("Peacock")
                local seconds = GetTime()
                for i=1,1000 do
                    pcUF:AURA('','target')
                end
                UpdateAddOnCPUUsage()
                UpdateAddOnMemoryUsage()
                pcUF:Print('GetAddOnCPUUsage')
                pcUF:Print(GetAddOnCPUUsage("Peacock")-currentCPU)
                pcUF:Print('GetAddOnMemoryUsage')
                pcUF:Print(GetAddOnMemoryUsage("Peacock")-currentmem)
                pcUF:Print('seconds of calcs')
                pcUF:Print(GetTime()-seconds)
            end,
        },
        randomtest={
            name="random test",
            desc="random tests",
            type="execute",
            func=function()
                myUI.player.Status()
            end,
        },
	},
}

local myUI = {} -- all frames/textures/functions that are frame/txture specific are in this table
function pcUF:OnInitialize()
    self:HideBlizzardFrames()
    CenterRotation = self:CreateRotationSetup(.5,.5,0.1,0,0,0,1,1,0,1,1)
    myUI.pettarget = self:SetupUnitFrame('pettarget', 'left', size, xoffset, yoffset)
    myUI.player = self:SetupUnitFrame('player', 'center', size, xoffset, yoffset)
    myUI.pet = self:SetupUnitFrame('pet', 'right', size, xoffset, yoffset)
    myUI.targettarget = self:SetupUnitFrame('targettarget', 'left', size, -xoffset, yoffset)
    myUI.target = self:SetupUnitFrame('target', 'center', size, -xoffset, yoffset)
    myUI.focus = self:SetupUnitFrame('focus', 'right', size, -xoffset, yoffset)
    
    self:SetupAura('target','LEFT') -- adds aura frames tot eh target frame
    
    
    self:Registerstuff()
    for k in pairs(units) do
        if UnitExists(k) then
            self:UPDATE(k)
        end
    end
	self:Print('Peacock Frames are loaded')
end

--events hurray
local events = {
    ['UNIT_HEALTH'] = function(event,arg1)
		pcUF:HEALTH(event,arg1)
	end,
    ['UNIT_MAXHEALTH'] = function(event,arg1)
		pcUF:HEALTH(event,arg1)
	end,
        
	['UNIT_ENERGY'] = function(event,arg1)
		pcUF:POWER(event,arg1)
	end,
    ['UNIT_MAXENERGY'] = function(event,arg1)
		pcUF:POWER(event,arg1)
	end,
    ['UNIT_FOCUS'] = function(event,arg1)
		pcUF:POWER(event,arg1)
	end,
    ['UNIT_MAXFOCUS'] = function(event,arg1)
		pcUF:POWER(event,arg1)
	end,
    ['UNIT_MANA'] = function(event,arg1)
		pcUF:POWER(event,arg1)
	end,
    ['UNIT_MAXMANA'] = function(event,arg1)
		pcUF:POWER(event,arg1)
	end,
    ['UNIT_RAGE'] = function(event,arg1)
		pcUF:POWER(event,arg1)
	end,
    ['UNIT_MAXRAGE'] = function(event,arg1)
		pcUF:POWER(event,arg1)
	end,
        
	['UNIT_LEVEL'] = function(event,arg1)
		pcUF:LEVEL(event,arg1)
	end,
    ['UNIT_NAME_UPDATE'] = function(event,arg1)
		pcUF:NAME(event,arg1)
	end,
        
    ['PLAYER_TARGET_CHANGED'] = function()
		pcUF:UPDATE('target')
	end,
    ['PLAYER_FLAGS_CHANGED'] = function(event,arg1)
		pcUF:UPDATEALL(event,arg1)
	end,
        
    ['UNIT_AURASTATE'] = function(event,arg1)
		pcUF:AURA(event,arg1)
	end,
    ['UNIT_AURA'] = function(event,arg1)
		pcUF:AURA(event,arg1)
	end,
    ['PLAYER_FOCUS_CHANGED'] = function()
		pcUF:UPDATE('focus')
	end,
    ['RAID_TARGET_UPDATE'] = function()
		pcUF:RICON()
	end,
    
    ['PLAYER_REGEN_DISABLED'] = function()
		myUI.player.Status()
	end,
    ['PLAYER_REGEN_ENABLED'] = function()
		myUI.player.Status()
	end,
    ['PLAYER_UPDATE_RESTING'] = function()
		myUI.player.Status()
	end,
    
    ['UNIT_FACTION'] = function(event,arg1)
		pcUF:PVP(event,arg1)
	end,
    
    ['PARTY_LOOT_METHOD_CHANGED'] = function(event,arg1)
		pcUF:MASTER()
	end,

    ['PARTY_LEADER_CHANGED'] = function(event,arg1)
		pcUF:LEADER()
	end,
    ['PARTY_MEMBERS_CHANGED'] = function(event,arg1)
		pcUF:LEADER()
	end,
}

function pcUF:LEADER()
    if UnitInRaid("player") then
        if UnitInRaid("target") then
            for i=1,40 do
                if  UnitIsUnit('raid'..i, 'player') then
                    local _, rank = GetRaidRosterInfo(raidIndex)
                    myUI.player.LEADER(rank)
                elseif UnitIsUnit('raid'..i, 'target') then
                    local _, rank = GetRaidRosterInfo(raidIndex)
                    myUI.target.LEADER(rank)
                end
            end
        else
            if IsRaidLeader() then
                myUI.player.LEADER(2)
            elseif IsRaidOfficer() then
                myUI.player.LEADER(1)
            else
                myUI.player.LEADER(0)
            end
        end
    end
    pcUF:MASTER()
end

function pcUF:MASTER()
    local lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod()
    if lootmethod == 'master' then
        if masterlooterPartyID then
            if masterlooterPartyID == 0 then
                myUI.player.Master(true)
                myUI.target.Master(false)
            else
                if UnitIsUnit('party'..masterlooterPartyID, 'target') then
                    myUI.target.Master(true)
                    myUI.player.Master(false)
                end
            end
        else
            if masterlooterRaidID and UnitIsUnit('raid'..masterlooterRaidID, 'target') then
                myUI.target.Master(true)
                myUI.player.Master(false)
            end
        end
    end
end

function pcUF:PVP(event,arg1)
    if arg1 == 'player' then
        local factionGroup = UnitFactionGroup("player")
        if ( factionGroup and UnitIsPVP("player") ) then
            myUI.player.PVP("Interface\\TargetingFrame\\UI-PVP-"..factionGroup)
        elseif ( UnitIsPVPFreeForAll("player") ) then
            myUI.player.PVP("Interface\\TargetingFrame\\UI-PVP-FFA")
        else
            myUI.player.PVP(false)
        end
    elseif arg1 == 'target' then
        local factionGroup = UnitFactionGroup("target")
        if ( factionGroup and UnitIsPVP("target") ) then
            myUI.target.PVP("Interface\\TargetingFrame\\UI-PVP-"..factionGroup)
        elseif ( UnitIsPVPFreeForAll("target") ) then
            myUI.target.PVP("Interface\\TargetingFrame\\UI-PVP-FFA")
        else
            myUI.target.PVP(false)
        end
    end
end

local eventFrame = CreateFrame("Frame")
	eventFrame:SetScript("OnEvent", function(this, event, ...)
		events[event](event,...)
	end)
	
function pcUF:Registerstuff()
	for event in pairs(events) do
		eventFrame:RegisterEvent(event)
	end
	--eventFrame:Show()
end

-- on update timer (lets make sure we dont update every frame :P )
local time = {}
local OnUpdate = function(self, a1)
	time[self.unit] = time[self.unit] or 0
	time[self.unit] = time[self.unit] + a1
	
	if(time[self.unit] > .5) then
		pcUF:UPDATE(self.unit)
		time[self.unit] = 0
	end
end

-- Hide Bliz player/pet/target/tot frames
local dummy = function() end

function pcUF:HideBlizzardFrames()
    PlayerFrame:UnregisterAllEvents()
    PlayerFrame.Show = dummy
    PlayerFrame:Hide()
    PlayerFrameHealthBar:UnregisterAllEvents()
    PlayerFrameManaBar:UnregisterAllEvents()
    PetFrame:UnregisterAllEvents()
    PetFrame.Show = dummy
    PetFrame:Hide()
    PetFrameHealthBar:UnregisterAllEvents()
    PetFrameManaBar:UnregisterAllEvents()
    TargetFrame:UnregisterAllEvents()
    TargetFrame.Show = dummy
    TargetFrame:Hide()
    TargetFrameHealthBar:UnregisterAllEvents()
    TargetFrameManaBar:UnregisterAllEvents()
    TargetFrameSpellBar:UnregisterAllEvents()
    ComboFrame:UnregisterAllEvents()
    ComboFrame.Show = dummy
    ComboFrame:Hide()
    TargetofTargetFrame:UnregisterAllEvents()
    TargetofTargetFrame.Show = dummy
    TargetofTargetFrame:Hide()
    TargetofTargetHealthBar:UnregisterAllEvents()
    TargetofTargetManaBar:UnregisterAllEvents()
end

local BuffFrames, DeBuffFrames

function pcUF:RICON()
    for k in pairs(units) do
        if UnitExists(k) then
            myUI[k]:RaidIcon()
        end
    end
end

function pcUF:AURA(event, arg1)
    if arg1 == 'target' then
        self:ScanBuffs(arg1)
        self:ScanDeBuffs(arg1)
        local buffcount = #TableOfBuffs + #TableOfBuffsTime
        local buffcountnotime = #TableOfBuffs
        BuffFrames = myUI[arg1].Buff
        for i,v in ipairs(BuffFrames) do
            local buff
            local index
            if i <= buffcountnotime then
                buff = TableOfBuffs
                index = i
            else
                buff = TableOfBuffsTime
                index = i - buffcountnotime
            end
            if i <= buffcount then
                if BuffFrames[i].icon:GetTexture() ~= buff[index].iconTexture then
                    BuffFrames[i].icon:SetTexture(buff[index].iconTexture)
                end
                
                local duration, timeLeft = buff[index].duration, buff[index].timeLeft
                if(duration and duration > 0) then
					BuffFrames[i].cd:SetCooldown(GetTime()-(duration-timeLeft), duration)
					BuffFrames[i].cd:Show()
				else
					BuffFrames[i].cd:Hide()
				end
                BuffFrames[i]:SetID(buff[index].index)
                BuffFrames[i]:Show()
            else
                BuffFrames[i]:Hide()
            end
        end
        local debuffcount = #TableOfDeBuffs + #TableOfDeBuffsTime
        local debuffcountnotime = #TableOfDeBuffs
        DeBuffFrames = myUI[arg1].DeBuff
        for i,v in ipairs(DeBuffFrames) do
            local debuff
            local index
            if i <= debuffcountnotime then
                debuff = TableOfDeBuffs
                index = i
            else
                debuff = TableOfDeBuffsTime
                index = i - debuffcountnotime
            end
            if i <= debuffcount then
                if DeBuffFrames[i].icon:GetTexture() ~= debuff[index].iconTexture then
                    DeBuffFrames[i].icon:SetTexture(debuff[index].iconTexture)
                end
                local duration, timeLeft = debuff[index].duration, debuff[index].timeLeft
                if(duration and duration > 0) then
					DeBuffFrames[i].cd:SetCooldown(GetTime()-(duration-timeLeft), duration)
					DeBuffFrames[i].cd:Show()
				else
					DeBuffFrames[i].cd:Hide()
				end
                
                DebuffColor = DebuffTypeColor[debuff[index].debuffType or "none"]
                DeBuffFrames[i].mask:SetVertexColor(DebuffColor.r, DebuffColor.g, DebuffColor.b)
                DeBuffFrames[i]:SetID(debuff[index].index)
                DeBuffFrames[i]:Show()
            else
                DeBuffFrames[i]:Hide()
            end
        end
    end
end

function pcUF:HEALTH(event, arg1)
    if units[arg1] then
        local min_prime = UnitHealth(arg1)
        if min_prime and (unitHealth[arg1] ~= min_prime) then
            unitHealth[arg1] = min_prime
            local min, max = mh4:GetUnitCurrentHP(arg1), mh4:GetUnitMaxHP(arg1)
            if max == 0 then max = 1 end
            if min/max > .5 then
                myUI[arg1].HealthColor(2*(1-(min/max)),1,0,1)
            else
                myUI[arg1].HealthColor(1,2*min/max,0,1)
            end
            myUI[arg1].Health(min,max)
            if (UnitIsTapped(arg1)) and (not UnitIsTappedByPlayer(arg1)) then
                unitName[arg1] = '|cff7f7f7f'..UnitName(arg1)..'|r'
                myUI[arg1].Name()
            end
        end
    end
end

function pcUF:POWER(event, arg1)
    if units[arg1] then
        local min = UnitMana(arg1)
        if min and (unitPower[arg1] ~= min) then
            unitPower[arg1] = min
            local max = UnitManaMax(arg1)
            local powertype = UnitPowerType(arg1)
            myUI[arg1].PowerColor(powercolor[powertype].r,powercolor[powertype].g,powercolor[powertype].b)
            myUI[arg1].Power(min,max)
            if (UnitIsTapped(arg1)) and (not UnitIsTappedByPlayer(arg1)) then
                unitName[arg1] = '|cff7f7f7f'..UnitName(arg1)..'|r'
                myUI[arg1].Name()
            end
        end
    end
end

function pcUF:NAME(event, arg1)
    if units[arg1] then
        local name = UnitName(arg1)
        if name then
            local _, class = UnitClass(arg1)
            for k in pairs(color) do color[k] = nil end
            if ((UnitIsTapped(arg1)) and (not UnitIsTappedByPlayer(arg1))) or UnitIsDead(arg1) then
                color.r = .5*255
                color.g = .5*255
                color.b = .5*255
            else
                color.r = RAID_CLASS_COLORS[class].r*255
                color.g = RAID_CLASS_COLORS[class].g*255
                color.b = RAID_CLASS_COLORS[class].b*255
            end
            local hex = string.format("%02x%02x%02x%02x", color.a or 255, color.r or 255, color.g or 255, color.b or 255)
            name = '|c'..hex..name..'|r'
            if UnitIsDND(arg1) then
                name = '|cff0000ffDND|r '..name
            end
            if UnitIsAFK(arg1) then
                name = '|cffff0000AFK|r '..name
            end
            unitName[arg1] = name
            myUI[arg1].Name()
        end
    end
    if arg1 == 'player' then
        pcUF:PVP(nil,'player')
        myUI.player.Status()
        pcUF:LEADER()
        pcUF:MASTER()
    elseif arg1 == 'target' then
        pcUF:PVP(nil,'target')
        pcUF:LEADER()
        pcUF:MASTER()
    end
end

function pcUF:LEVEL(event, arg1)
    if units[arg1] then
        local level = UnitLevel(arg1)
        if level and (unitLevelraw[arg1] ~= level) then
            unitLevelraw[arg1] = level
            if level == -1 then level = '??' end
            local classification = UnitClassification(arg1)
            if classification == 'worldboss' then
                level = 'B'
            elseif classification == 'rareelite' or classification == 'elite' then
                level = '+'..level
            end
            for k in pairs(color) do color[k] = nil end
            if UnitIsTrivial(arg1) then
                color.r = .5*255
                color.g = .5*255
                color.b = .5*255
            else
                color.r = 255
                color.g = 255
                color.b = 255
            end
            local hex = string.format("%02x%02x%02x%02x", color.a or 255, color.r or 255, color.g or 255, color.b or 255)
            unitLevel[arg1] = '|c'..hex..level..'|r'
            myUI[arg1].Level()
        end
    end
end

function pcUF:UPDATE(unit)
    self:HEALTH('', unit)
    self:POWER('', unit)
    self:LEVEL('', unit)
    self:NAME('', unit)
    self:RICON()
    if unit == 'target' then
        self:AURA('',unit)
    end
end

function pcUF:UPDATEALL(event, arg1)
    self:UPDATE(arg1)
end

-- creates dropdown menu for Unitframes
local menu = function(self)
	local unit = self.unit:sub(1, -2)
	local cunit = self.unit:gsub("(.)", string.upper, 1)

	if(unit == "party" or unit == "partypet") then
		ToggleDropDownMenu(1, nil, _G["PartyMemberFrame"..self.id.."DropDown"], "cursor", 0, 0)	
	elseif(_G[cunit.."FrameDropDown"]) then
		ToggleDropDownMenu(1, nil, _G[cunit.."FrameDropDown"], "cursor", 0, 0)
	end
end
-- create dropdown menu for Aura Frames
local debuffOnEnter = function(self)
	if(not self:IsVisible()) then return end
	local unit = self.unit
    
	GameTooltip:SetOwner(self, "ANCHOR_BOTTOMRIGHT")

	GameTooltip:SetUnitDebuff(unit, self:GetID())
end

local buffOnEnter = function(self)
	if(not self:IsVisible()) then return end
	local unit = self.unit

	GameTooltip:SetOwner(self, "ANCHOR_BOTTOMRIGHT")

	GameTooltip:SetUnitBuff(unit, self:GetID())
end

local onLeave = function()
	GameTooltip:Hide()
end

function pcUF:ScanBuffs(unit)
    local i = 1
    local n = 0
    local nt = 0
    repeat
        local name, rank, iconTexture, count, duration, timeLeft =  UnitBuff(unit, i)
        if not name then break end
        if timeLeft and timeLeft ~= 0 then
            nt = nt+1
            TableOfBuffsTime[nt] = TableOfBuffsTime[nt] or tremove(BuffsubTableNotInUse) or {}
            TableOfBuffsTime[nt]['name'] = name
            TableOfBuffsTime[nt]['index'] = i
            TableOfBuffsTime[nt]['rank'] = rank
            TableOfBuffsTime[nt]['iconTexture'] = iconTexture
            TableOfBuffsTime[nt]['count'] = count
            TableOfBuffsTime[nt]['duration'] = duration
            TableOfBuffsTime[nt]['timeLeft'] = timeLeft
        else
            n = n+1
            TableOfBuffs[n] = TableOfBuffs[n] or tremove(BuffsubTableNotInUse) or {}
            TableOfBuffs[n]['name'] = name
            TableOfBuffs[n]['index'] = i
            TableOfBuffs[n]['rank'] = rank
            TableOfBuffs[n]['iconTexture'] = iconTexture
            TableOfBuffs[n]['count'] = count
            TableOfBuffs[n]['duration'] = duration
            TableOfBuffs[n]['timeLeft'] = timeLeft
        end
        i = i + 1
    until false

    for i = #TableOfBuffs,n+1,-1 do
        BuffsubTableNotInUse[#BuffsubTableNotInUse+1] = tremove(TableOfBuffs)
    end    
    for i = #TableOfBuffsTime,nt+1,-1 do
        BuffsubTableNotInUse[#BuffsubTableNotInUse+1] = tremove(TableOfBuffsTime)
    end

    tsort(TableOfBuffs, function(a,b) return a['name'] < b['name'] end)
    tsort(TableOfBuffsTime, function(a,b) return a['timeLeft'] > b['timeLeft'] end)
end

function pcUF:ScanDeBuffs(unit)
	local i = 1
    local n = 0
    local nt = 0
	repeat
		local name, rank, iconTexture, count, debuffType, duration, timeLeft =  UnitDebuff('target', i)
		if not name then break end
		if timeLeft and timeLeft ~= 0 then
            nt = nt+1
            TableOfDeBuffsTime[nt] = TableOfDeBuffsTime[nt] or tremove(DeBuffsubTableNotInUse) or {}
            TableOfDeBuffsTime[nt]['name'] = name
            TableOfDeBuffsTime[nt]['index'] = i
            TableOfDeBuffsTime[nt]['iconTexture'] = iconTexture
            TableOfDeBuffsTime[nt]['count'] = count
            TableOfDeBuffsTime[nt]['debuffType'] = debuffType
            TableOfDeBuffsTime[nt]['duration'] = duration
            TableOfDeBuffsTime[nt]['timeLeft'] = timeLeft
		else
            n=n+1
            TableOfDeBuffs[n] = TableOfDeBuffs[n] or tremove(DeBuffsubTableNotInUse) or {}
            TableOfDeBuffs[n]['name'] = name
            TableOfDeBuffs[n]['index'] = i
            TableOfDeBuffs[n]['iconTexture'] = iconTexture
            TableOfDeBuffs[n]['count'] = count
            TableOfDeBuffs[n]['debuffType'] = debuffType
            TableOfDeBuffs[n]['duration'] = duration
            TableOfDeBuffs[n]['timeLeft'] = timeLeft
		end
		i = i + 1
	until false
    
    for i = #TableOfDeBuffs,n+1,-1 do
        DeBuffsubTableNotInUse[#DeBuffsubTableNotInUse+1] = tremove(TableOfDeBuffs)
    end    
    for i = #TableOfDeBuffsTime,nt+1,-1 do
        DeBuffsubTableNotInUse[#DeBuffsubTableNotInUse+1] = tremove(TableOfDeBuffsTime)
    end

	tsort(TableOfDeBuffs, function(a,b) return a['name'] < b['name'] end)
	tsort(TableOfDeBuffsTime, function(a,b) return a['timeLeft'] > b['timeLeft'] end)
end

--adds 40buff and 40 debuff frames to the specific unit
--unit = unitid
--buffside = LEFT or RIGHT (side you want the buffs on :)
function pcUF:SetupAura(unit,buffside)
    if (not unit or not buffside) or not (buffside == 'LEFT' or buffside == 'RIGHT') then return nil end
-- left
    local LeftFrame={}
    local multiplier = .8
    local startangle = 17
    local stopangle = 90
    local level = 1
    local AuraAngle = 0
    
    local totalangle = stopangle-startangle
    local width = ((2*aurasize^2)^(1/2)+1)
    local radius = size*multiplier
    
    local levelcount={}
    for i=1,40 do
        local currentloc = i
        if not levelcount[level] then
            local minangle = math.deg(math.acos(((2*(radius+((level-1)*width))^2)-width^2)/(2*(radius+((level-1)*width))^2)))
            levelcount[level] = math.floor(totalangle/minangle)+1
            AuraAngle = totalangle/(levelcount[level]-1)
        end
        for _,v in ipairs(levelcount) do
            if currentloc-v > 0 then
                currentloc = currentloc-v
            end
        end
        currentloc = currentloc - 1
        local f = CreateFrame("Frame",nil,myUI[unit])
            f:SetFrameStrata("BACKGROUND")
            f:SetPoint("CENTER",(radius+((level-1)*width))*math.sin(math.rad(-1*((AuraAngle*currentloc)+startangle))),(radius+((level-1)*width))*math.cos(math.rad(-1*((AuraAngle*currentloc)+startangle))))
            f:SetWidth(aurasize)
            f:SetHeight(aurasize)
            f:EnableMouse(true)
            if buffside == 'LEFT' then
                f:SetScript("OnEnter", buffOnEnter)
            else
                f:SetScript("OnEnter", debuffOnEnter)
            end
            f:SetScript("OnLeave", onLeave)
            f.unit = unit
        local t = f:CreateTexture(nil,"BACKGROUND")
            t:SetTexture('Interface\\Icons\\Spell_Nature_EarthBindTotem.blp')
            t:SetTexCoord(CenterRotation((AuraAngle*currentloc)+startangle))
            t:SetAllPoints(f)
        f.icon = t
        local mf = CreateFrame("Frame",nil,f)
            mf:SetFrameStrata("LOW")
            mf:SetAllPoints(f)
            mf:Show()
        local m = mf:CreateTexture(nil,"BORDER")
            m:SetTexture("Interface\\AddOns\\Peacock\\textures\\auramask.tga")
            m:SetPoint('Center',0,0)
            m:SetWidth(aurasize*128/89)
            m:SetHeight(aurasize*128/89)
            m:SetVertexColor(.5,.5,.5)
        f.mask = m
        local cd = CreateFrame("Cooldown", nil, f)
            cd:SetAllPoints(f)
        f.cd = cd
        
        LeftFrame[i] = f
        
        if currentloc+1 == levelcount[level] then level = level + 1 end
    end
    if buffside == 'LEFT' then
        myUI[unit].Buff = LeftFrame
    else
        myUI[unit].DeBuff = LeftFrame
    end
    -- right
    RightFrame={}
    startangle = -17
    stopangle = -90
    level = 1
    AuraAngle = 0
    
    totalangle = math.abs(stopangle-startangle)
    
    local levelcount={}
    for i=1,40 do
        local currentloc = i
        if not levelcount[level] then
            local minangle = math.deg(math.acos(((2*(radius+((level-1)*width))^2)-width^2)/(2*(radius+((level-1)*width))^2)))
            levelcount[level] = math.floor(totalangle/minangle)+1
            AuraAngle = totalangle/(levelcount[level]-1)
        end
        for _,v in ipairs(levelcount) do
            if currentloc-v > 0 then
                currentloc = currentloc-v
            end
        end
        currentloc = currentloc - 1
        local f = CreateFrame("Frame",nil,myUI[unit])
            f:SetFrameStrata("BACKGROUND")
            f:SetPoint("CENTER",(radius+((level-1)*width))*math.sin(math.rad(-1*((-AuraAngle*currentloc)+startangle))),(radius+((level-1)*width))*math.cos(math.rad(-1*((-AuraAngle*currentloc)+startangle))))
            f:SetWidth(aurasize)
            f:SetHeight(aurasize)
            f:EnableMouse(true)
            if buffside == 'RIGHT' then
                f:SetScript("OnEnter", buffOnEnter)
            else
                f:SetScript("OnEnter", debuffOnEnter)
            end
            f:SetScript("OnLeave", onLeave)
            f.unit = unit
        local t = f:CreateTexture(nil,"BACKGROUND")
            t:SetTexture('Interface\\Icons\\Spell_Nature_lightningShield.blp')
            t:SetTexCoord(CenterRotation((-AuraAngle*currentloc)+startangle))
            t:SetAllPoints(f)
        f.icon = t
        local mf = CreateFrame("Frame",nil,f)
            mf:SetFrameStrata("LOW")
            mf:SetAllPoints(f)
            mf:Show()
        local m = mf:CreateTexture(nil,"BORDER")
            m:SetTexture("Interface\\AddOns\\Peacock\\textures\\auramask.tga")
            m:SetPoint('Center',0,0)
            m:SetWidth(aurasize*128/89)
            m:SetHeight(aurasize*128/89)
            m:SetVertexColor(.5,.5,.5)
        f.mask = m
        local cd = CreateFrame("Cooldown", nil, f)
            cd:SetAllPoints(f)
        f.cd = cd
        RightFrame[i] = f
        
        if currentloc+1 == levelcount[level] then level = level + 1 end
    end
    if buffside == 'RIGHT' then
        myUI[unit].Buff = RightFrame
    else
        myUI[unit].DeBuff = RightFrame
    end
end


-- creates a unitframe a certain style at a cetain position
---- unit = unitID
---- style = string > left,center,right
---- size = number > size of center frame. left and right should be the same at the same pos to look right
---- posX = number > 0 is center of screen
---- posY = number > 0 is center of screen
-- returns frame
function pcUF:SetupUnitFrame(unit,style,size,posX,posY)
    local smallsize = size/2
    local bigsize = size*(682/512)/2
    local bottomsize = size*150/512
    local textsize = size/10
    local top
    if style == 'center' then
        top = smallsize
    else
        top = bigsize
    end
    local cr = .15
    local cg = .15
    local cb = .15
    local childcount = 0
    local f = CreateFrame("Frame","Yss_"..unit.."_Frame",UIParent,"SecureStateHeaderTemplate")
    f:SetFrameStrata("LOW")
    f:SetWidth(size)  -- Set These to whatever height/width is needed 
    f:SetHeight(size) -- for your Texture
    f:SetPoint("CENTER",posX,posY)
    f.unit = unit
    f:SetAttribute("unit", unit)
    f:SetScript("OnShow", function() self:UPDATE(unit) end)
    if unit == 'targettarget' or unit == 'pettarget' then
        f:SetScript("OnUpdate", OnUpdate)
    end
    RegisterUnitWatch(f)
    f.b = {}
    Testtable = {}
    for i=-bottomsize,math.floor(top),steps do
        childcount = childcount + 1
        local small, big, width, pos --pos is a sign setter
        if style == 'center' then
            if i >= 0 then
                big = 2*smallsize*math.cos(math.asin((i+steps/2)/smallsize))
            else
                big = 2*(bottomsize*math.cos(math.asin((i-steps/2)/bottomsize))+smallsize-bottomsize)
            end
            pos = 0
        else
            if i >= 0 then
                big = bigsize*math.cos(math.asin((i+steps/2)/bigsize))
                small = smallsize*math.cos(math.asin((i-steps/2)/smallsize))
            else
                big = (bottomsize*math.cos(math.asin((i-steps/2)/bottomsize)))+(bigsize-bottomsize)
                small = (bottomsize*math.cos(math.asin((i+steps/2)/bottomsize)))+(smallsize-bottomsize)
            end
            if style == 'left' then
                pos = -1
            else
                pos = 1
            end
        end
        if not ((big >= 0) or (big<=0)) then big = 0 end
        small = small or 0
        if not ((small >= 0) or (small<=0)) then small = 0 end
        local b = CreateFrame("Button","Yss_"..unit.."_Frame_"..childcount,f,"SecureUnitButtonTemplate")
        b:SetAttribute("unit", unit)
        b:SetAttribute("type1", "target")
        b:SetWidth(big-small)
        b:SetHeight(steps)
        b.unit = unit
        b.menu = menu
        b:RegisterForClicks"anyup"
        b:SetPoint("CENTER",pos*(big+small)/2,i)
        b:SetAttribute("*type2", "menu")

        b:SetScript("OnEnter", UnitFrame_OnEnter)
        b:SetScript("OnLeave", UnitFrame_OnLeave)
        --[[local t = b:CreateTexture(nil,'Overlay')
            t:SetTexture(.5,.5,0,.5)
            t:SetAllPoints(b)]]-- uncommenting this will apply an overlay to the actual clickable area
        f:SetAttribute("addchild", b)
        f.b[i] = b
    end
    if style == 'center' then
        local texture = CreateFrame("Frame",nil,f)
        texture:SetAllPoints(f)
        local p = texture:CreateTexture(nil,"ARTWORK")
            p:SetTexture("Interface\\AddOns\\Peacock\\textures\\Primary.tga")
            p:SetAllPoints(texture)
            p:SetVertexColor(cr, cg, cb)
        texture.overlay = p
        local pb = texture:CreateTexture(nil,"BACKGROUND")
            pb:SetTexture("Interface\\AddOns\\Peacock\\textures\\PBack.tga")
            pb:SetAllPoints(texture)
            pb:SetVertexColor(cr,cg,cb,.75)
        texture.background = pb
        
        texture.minHealth = 11.8
        texture.maxHealth = -178.8
        texture.health = {}
        for i=-1,math.floor((texture.maxHealth-texture.minHealth)/5),-1 do
            local angle = texture.minHealth+((i)*5)
            local rh = texture:CreateTexture(nil,"BORDER")
                rh:SetTexture("Interface\\AddOns\\Peacock\\textures\\PH.tga")
                rh:SetAllPoints(texture)
                rh:SetTexCoord(CenterRotation(angle))
                rh.angle = angle
                rh:Hide()
            texture.health[-1*i] = rh
        end
        
        texture.minPower = 13.2
        texture.maxPower = -180.8
        texture.power = {}
        for i=-1,math.floor((texture.maxPower-texture.minPower)/5),-1 do
            local angle = texture.minPower+((i)*5)
            local rm = texture:CreateTexture(nil,"BORDER")
                rm:SetTexture("Interface\\AddOns\\Peacock\\textures\\PM.tga")
                rm:SetAllPoints(texture)
                rm:SetTexCoord(CenterRotation(angle))
                rm.angle = angle
                rm:Hide()
            texture.power[-1*i] = rm
        end

        local p = texture:CreateTexture(nil,"ARTWORK")
            p:SetTexture("Interface\\AddOns\\Peacock\\textures\\Primary.tga")
            p:SetAllPoints(texture)
            p:SetVertexColor(cr, cg, cb)
        texture.overlay = p
        
        local icon = texture:CreateTexture(nil, "OVERLAY")
            icon:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons")
            icon:SetWidth(size/8)
            icon:SetHeight(size/8)
            icon:SetPoint("CENTER", 0, size*.65)
            icon:Hide()
        texture.RaidIcon = icon
        
        local ht = texture:CreateFontString(nil,"OVERLAY")
            ht:SetFont(font,textsize)
            ht:SetJustifyH('CENTER')
            ht:SetJustifyV('CENTER')
            ht:SetPoint('CENTER',0,-1*(size/9.1))
            ht:SetTextColor(0,1,0,1)
        texture.healthtext = ht
        
        local pt = texture:CreateFontString(nil,"OVERLAY")
            pt:SetFont(font,textsize)
            pt:SetJustifyH('CENTER')
            pt:SetJustifyV('CENTER')
            pt:SetPoint('CENTER',0,(-1*(size/9.1))-textsize)
            pt:SetTextColor(0,0,1,1)
        texture.powertext = pt

        local nt = texture:CreateFontString(nil,"OVERLAY")
            nt:SetFont(font,textsize*1.25,'OUTLINE')
            nt:SetJustifyH('CENTER')
            nt:SetJustifyV('CENTER')
            nt:SetPoint('CENTER',0,-1*(size/2.7))
            nt:SetTextColor(1,0,1,1)
        texture.nametext = nt

        if f.unit == 'player' then
            local status = CreateFrame("Frame",nil,f)
                status:SetWidth(textsize)
                status:SetHeight(textsize)
                status:SetPoint("CENTER", 0, 0)

                local rest = status:CreateTexture(nil, "OVERLAY")
                    rest:SetTexture("Interface\\CharacterFrame\\UI-StateIcon")
                    rest:SetTexCoord(0,0.5,0,0.421875)
                    rest:SetWidth(textsize*2)
                    rest:SetHeight(textsize*2)
                    rest:SetPoint("CENTER")
                    rest:Hide()
                status.Rest = rest

                local attack = status:CreateTexture(nil, "OVERLAY")
                    attack:SetTexture("Interface\\CharacterFrame\\UI-StateIcon")
                    attack:SetTexCoord(0.5,1.0,0,0.5)
                    attack:SetWidth(textsize*2)
                    attack:SetHeight(textsize*2)
                    attack:SetPoint("CENTER")
                    attack:Hide()
                status.Attack = attack

            f.status = status
            f.Status = function()
                if texture.PVPicon:IsShown() then
                    f.status:SetPoint("Center", textsize*3+(nt:GetStringWidth()/2), -1*(size/2.7))
                else
                    f.status:SetPoint("Center", textsize+(nt:GetStringWidth()/2), -1*(size/2.7))
                end
                if UnitAffectingCombat('player') then
                    rest:Hide()
                    attack:Show()
                elseif IsResting() then
                    rest:Show()
                    attack:Hide()
                else
                    rest:Hide()
                    attack:Hide()
                end
            end
        end
        
        local PVPicon = texture:CreateTexture(nil, "OVERLAY")
            PVPicon:SetWidth(textsize*3)
            PVPicon:SetHeight(textsize*3)
            PVPicon:SetPoint("CENTER")
            PVPicon:Hide()
        texture.PVPicon = PVPicon

        local Master = texture:CreateTexture(nil, "OVERLAY")
            Master:SetTexture("Interface\\GroupFrame\\UI-Group-MasterLooter")
            Master:SetWidth(textsize*1.5)
            Master:SetHeight(textsize*1.5)
            Master:SetPoint("CENTER")
            Master:Hide()
        texture.Master = Master

        local Leader = texture:CreateTexture(nil, "OVERLAY")
            Leader:SetTexture("Interface\\GroupFrame\\UI-Group-LeaderIcon")
            Leader:SetWidth(textsize*1.5)
            Leader:SetHeight(textsize*1.5)
            Leader:SetPoint("CENTER")
            Leader:Hide()
        texture.Leader = Leader
        
        f.LEADER = function(rank)
            if texture.Master:IsShown() then
                f.texture.Leader:SetPoint("Center", -textsize*2.5-(nt:GetStringWidth()/2), -1*(size/2.7))
            else
                f.texture.Leader:SetPoint("Center", -textsize-(nt:GetStringWidth()/2), -1*(size/2.7))
            end
            if rank == 2 then
                f.texture.Leader:SetTexture("Interface\\GroupFrame\\UI-Group-LeaderIcon")
                f.texture.Leader:Show()
            elseif rank == 1 then
                f.texture.Leader:SetTexture("Interface\\GroupFrame\\UI-Group-AssistantIcon")
                f.texture.Leader:Show()
            else
                f.texture.Leader:Hide()
            end
        end
        
        f.MASTER = function(master)
            if master then
                f.texture.Master:SetPoint("Center", -textsize-(nt:GetStringWidth()/2), -1*(size/2.7))
                f.texture.Master:Show()
                if f.texture.Leader:IsShown() then
                    f.texture.Leader:SetPoint("Center", -textsize*2.5-(nt:GetStringWidth()/2), -1*(size/2.7))
                end
            else
                f.texture.Master:Hide()
                if f.texture.Leader:IsShown() then
                    f.texture.Leader:SetPoint("Center", -textsize-(nt:GetStringWidth()/2), -1*(size/2.7))
                end
            end
        end
        
        f.PVP = function(icon)
            f.texture.PVPicon:SetPoint("Center", (textsize*3/2)+(nt:GetStringWidth()/2), -1*(size/2.7)-(textsize*3/4))
            if icon then
                f.texture.PVPicon:SetTexture(icon)
                f.texture.PVPicon:Show()
            else
                f.texture.PVPicon:Hide()
            end
        end
        
        f.texture = texture
        f.Name = function()
            f.texture.nametext:SetText(unitName[unit]..' '..unitLevel[unit])
        end
        f.Level = f.Name
    elseif style == 'left' then
        local size = size*(682/512)
        local texture = CreateFrame("Frame",nil,f)
        texture:SetPoint("CENTER")
        texture:SetWidth(size)
        texture:SetHeight(size)
        local l = texture:CreateTexture(nil,"ARTWORK")
            l:SetTexture("Interface\\AddOns\\Peacock\\textures\\Secondary.tga")
            l:SetAllPoints(texture)
            l:SetVertexColor(cr, cg, cb)
        texture.overlay = l
        local lb = texture:CreateTexture(nil,"BACKGROUND")
            lb:SetTexture("Interface\\AddOns\\Peacock\\textures\\SBack.tga")
            lb:SetAllPoints(texture)
            lb:SetVertexColor(cr,cg,cb,.75)
        texture.background = lb
        
        texture.minHealth = 9
        texture.maxHealth = -70.7
        texture.health = {}
        for i=-1,math.ceil((texture.maxHealth-texture.minHealth)/5)-1,-1 do
            local angle = texture.minHealth+((i)*5)
            local rh = texture:CreateTexture(nil,"BORDER")
                rh:SetTexture("Interface\\AddOns\\Peacock\\textures\\SH.tga")
                rh:SetAllPoints(texture)
                rh:SetTexCoord(CenterRotation(angle))
                rh.angle = angle
                rh:Hide()
            texture.health[-1*i] = rh
        end
        
        texture.minPower = 9.3
        texture.maxPower = -71
        texture.power = {}
        for i=-1,math.ceil((texture.maxPower-texture.minPower)/5)-1,-1 do
            local angle = texture.minPower+((i)*5)
            local rm = texture:CreateTexture(nil,"BORDER")
                rm:SetTexture("Interface\\AddOns\\Peacock\\textures\\SM.tga")
                rm:SetAllPoints(texture)
                rm:SetTexCoord(CenterRotation(angle))
                rm.angle = angle
                rm:Hide()
            texture.power[-1*i] = rm
        end
        
        local icon = texture:CreateTexture(nil, "OVERLAY")
            icon:SetTexture"Interface\\TargetingFrame\\UI-RaidTargetingIcons"
            icon:SetWidth(size/16)
            icon:SetHeight(size/16)
            icon:SetPoint("CENTER", -size/16, size*.42)
            icon:Hide()
        texture.RaidIcon = icon
        
        
        local nt = texture:CreateFontString(nil,"OVERLAY")
            nt:SetFont(font,textsize*1.25,'OUTLINE')
            nt:SetJustifyH('RIGHT')
            nt:SetJustifyV('CENTER')
            nt:SetPoint('TOPRIGHT',-(size*.95),-1*(size/1.6))
            nt:SetTextColor(1,0,1,1)
        texture.nametext = nt
        
        local lt = texture:CreateFontString(nil,"OVERLAY")
            lt:SetFont(font,textsize*.9)
            lt:SetJustifyH('CENTER')
            lt:SetJustifyV('CENTER')
            lt:SetPoint('CENTER',-1*(size/2.3),-1*(size/14))
            lt:SetTextColor(1,0,1,1)
        texture.leveltext = lt
        
        f.texture = texture
        f.Name = function()
            f.texture.nametext:SetText(unitName[unit])
        end
        f.Level = function()
            f.texture.leveltext:SetText(unitLevel[unit])
        end
        
    elseif style == 'right' then
        local size = size*(682/512)
        local texture = CreateFrame("Frame",nil,f)
        texture:SetPoint("CENTER")
        texture:SetWidth(size)
        texture:SetHeight(size)
        local r = texture:CreateTexture(nil,"ARTWORK")
            r:SetTexture("Interface\\AddOns\\Peacock\\textures\\Secondary.tga")
            r:SetAllPoints(texture)
            r:SetTexCoord(1,0,1,1,0,0,0,1)
            r:SetVertexColor(cr, cg, cb)
        texture.overlay = r
        local rb = texture:CreateTexture(nil,"BACKGROUND")
            rb:SetTexture("Interface\\AddOns\\Peacock\\textures\\SBack.tga")
            rb:SetAllPoints(texture)
            rb:SetTexCoord(1,0,1,1,0,0,0,1)
            rb:SetVertexColor(cr,cg,cb,.75)
        texture.background = rb
        
        texture.minHealth = 177
        texture.maxHealth = 256.7
        texture.health = {}
        for i=1,math.ceil((texture.maxHealth-texture.minHealth)/5) do
            local angle = texture.minHealth+((i)*5)
            local rh = texture:CreateTexture(nil,"BORDER")
                rh:SetTexture("Interface\\AddOns\\Peacock\\textures\\SH.tga")
                rh:SetAllPoints(texture)
                rh:SetTexCoord(CenterRotation(angle))
                rh.angle = angle
                rh:Hide()
            texture.health[i] = rh
        end
        
        texture.minPower = 176.7
        texture.maxPower = 257
        texture.power = {}
        for i=1,math.ceil((texture.maxPower-texture.minPower)/5) do
            local angle = texture.minPower+((i)*5)
            local rm = texture:CreateTexture(nil,"BORDER")
                rm:SetTexture("Interface\\AddOns\\Peacock\\textures\\SM.tga")
                rm:SetAllPoints(texture)
                rm:SetTexCoord(CenterRotation(angle))
                rm.angle = angle
                rm:Hide()
            texture.power[i] = rm
        end
        
        local icon = texture:CreateTexture(nil, "OVERLAY")
            icon:SetTexture"Interface\\TargetingFrame\\UI-RaidTargetingIcons"
            icon:SetWidth(size/16)
            icon:SetHeight(size/16)
            icon:SetPoint("CENTER", size/16, size*.42)
            icon:Hide()
        texture.RaidIcon = icon
        
        local nt = texture:CreateFontString(nil,"OVERLAY")
            nt:SetFont(font,textsize*1.25,'OUTLINE')
            nt:SetJustifyH('LEFT')
            nt:SetJustifyV('CENTER')
            nt:SetPoint('TOPLEFT',(size*.95),-1*(size/1.6))
            nt:SetTextColor(1,0,1,1)
        texture.nametext = nt
        
        local lt = texture:CreateFontString(nil,"OVERLAY")
            lt:SetFont(font,textsize*.9)
            lt:SetJustifyH('CENTER')
            lt:SetJustifyV('CENTER')
            lt:SetPoint('CENTER',(size/2.4),-1*(size/14))
            lt:SetTextColor(1,0,1,1)
        texture.leveltext = lt
        
        f.texture = texture
        f.Name = function()
            f.texture.nametext:SetText(unitName[unit])
        end
        f.Level = function()
            f.texture.leveltext:SetText(unitLevel[unit])
        end
    end
    
    f.RaidIcon = function()
        local icon = GetRaidTargetIndex(f.unit)
        if icon then
            SetRaidTargetIconTexture(f.texture.RaidIcon, icon)
            f.texture.RaidIcon:Show()
        else
            f.texture.RaidIcon:Hide()
        end
    end
    
    if style == 'right' then
        f.Health = function(current,max)
            local startAngle = f.texture.minHealth
            local stopAngle = ((current/max) * (f.texture.maxHealth-f.texture.minHealth))+startAngle
            for i=1,#f.texture.health do
                if i == #f.texture.health then
                    f.texture.health[i]:Show()
                    f.texture.health[i]:SetTexCoord(CenterRotation(stopAngle))
                elseif f.texture.health[i].angle < stopAngle then
                    f.texture.health[i]:Show()
                else
                    f.texture.health[i]:Hide()
                end
            end
        end
        
        f.Power = function(current,max)
            if max == 0 then max = 1 end
            local startAngle = f.texture.minPower
            local stopAngle = ((current/max) * (f.texture.maxPower-f.texture.minPower))+startAngle
            for i=1,#f.texture.power do
                if i == #f.texture.power then
                    f.texture.power[i]:Show()
                    f.texture.power[i]:SetTexCoord(CenterRotation(stopAngle))
                elseif f.texture.power[i].angle < stopAngle then
                    f.texture.power[i]:Show()
                else
                    f.texture.power[i]:Hide()
                end
            end
        end
    elseif  style == 'left' then
        f.Health = function(current,max)
            local startAngle = f.texture.minHealth
            local stopAngle = startAngle+((current/max) * (f.texture.maxHealth-f.texture.minHealth))
            for i=1,#f.texture.health do
                if i == #f.texture.health then
                    f.texture.health[i]:Show()
                    f.texture.health[i]:SetTexCoord(CenterRotation(stopAngle))
                elseif f.texture.health[i].angle > stopAngle then
                    f.texture.health[i]:Show()
                else
                    f.texture.health[i]:Hide()
                end
            end
        end
        
        f.Power = function(current,max)
            if max == 0 then max = 1 end
            local startAngle = f.texture.minPower
            local stopAngle = startAngle+((current/max) * (f.texture.maxPower-f.texture.minPower))
            for i=1,#f.texture.power do
                if i == #f.texture.power then
                    f.texture.power[i]:Show()
                    f.texture.power[i]:SetTexCoord(CenterRotation(stopAngle))
                elseif f.texture.power[i].angle > stopAngle then
                    f.texture.power[i]:Show()
                else
                    f.texture.power[i]:Hide()
                end
            end
        end
    else
        f.Health = function(current,max)
            local startAngle = f.texture.minHealth
            local stopAngle = startAngle+((current/max) * (f.texture.maxHealth-f.texture.minHealth))
            for i=1,#f.texture.health do
                if i == #f.texture.health then
                    f.texture.health[i]:Show()
                    f.texture.health[i]:SetTexCoord(CenterRotation(stopAngle))
                elseif f.texture.health[i].angle > stopAngle then
                    f.texture.health[i]:Show()
                else
                    f.texture.health[i]:Hide()
                end
            end
            if current ~= 0 then
                f.texture.healthtext:SetText(current..'/'..max)
            else
                f.texture.healthtext:SetText('Dead')
            end
        end
        
        f.Power = function(current,max)
            local calcmax = max
            if calcmax == 0 then calcmax = 1 end
            local startAngle = f.texture.minPower
            local stopAngle = startAngle+((current/calcmax) * (f.texture.maxPower-f.texture.minPower))
            for i=1,#f.texture.power do
                if i == #f.texture.power then
                    f.texture.power[i]:Show()
                    f.texture.power[i]:SetTexCoord(CenterRotation(stopAngle))
                elseif f.texture.power[i].angle > stopAngle then
                    f.texture.power[i]:Show()
                else
                    f.texture.power[i]:Hide()
                end
            end
            if max > 0 then
                f.texture.powertext:SetText(current..'/'..max)
            else
                f.texture.powertext:SetText('')
            end
        end
    
    end
    if style == 'center' then
        f.HealthColor = function(r,g,b,a)
            for i=1,#f.texture.health do
                f.texture.health[i]:SetVertexColor(r,g,b,a)
                f.texture.healthtext:SetTextColor(r,g,b,a)
            end
        end
        f.PowerColor = function(r,g,b,a)
            for i=1,#f.texture.power do
                f.texture.power[i]:SetVertexColor(r,g,b,a)
                f.texture.powertext:SetTextColor(r,g,b,a)
            end
        end
    else
        f.HealthColor = function(r,g,b,a)
            for i=1,#f.texture.health do
                f.texture.health[i]:SetVertexColor(r,g,b,a)
            end
        end
        f.PowerColor = function(r,g,b,a)
            for i=1,#f.texture.power do
                f.texture.power[i]:SetVertexColor(r,g,b,a)
            end
        end
    end
    return f
end

LibStub("AceConfig-3.0"):RegisterOptionsTable('Peacock', options)

function pcUF:OnEnable()
	self:RegisterChatCommand('pc', function() LibStub("AceConfigDialog-3.0"):Open("Peacock") end)
	SV = {}
end

-- the following code is for generating a rotation function
local cos = math.cos
local sin = math.sin
local rad = math.rad
local sqrt = math.sqrt
local atan2 = math.atan2
local floor = math.floor
local ceil = math.ceil
local pi = math.pi
local abs = math.abs

local function rotatepoint(X,Y,x,y,rotangle)
    local xX = x-X
    local yY = y-Y
	local length = sqrt(xX*xX+yY*yY)
	local angle = atan2(y-Y,xX) + rotangle
	return (length*cos(angle))+X, (length*sin(angle))+Y
end

-- set X and Y coordinates about wich to rotate a texture. returns a table that contains all coordinates for angles 0-360
-- resolutin will set the resolution of angles should be bigger or equal to 0 (0 is no resolution and table might grow infinitly)
-- ULx, ULy, LLx, LLy, URx, URy, LRx, LRy is the initial transformation of the texture
function pcUF:CreateRotationSetup(X, Y, resolution, ULx, ULy, LLx, LLy, URx, URy, LRx, LRy)
    local ULxtable = {}
    local ULytable = {}
    local LLxtable = {}
    local LLytable = {}
    local URxtable = {}
    local URytable = {}
    local LRxtable = {}
    local LRytable = {}
    rotfunction = function(angle)
        if ULxtable[angle] then
            return ULxtable[angle], ULytable[angle], LLxtable[angle], LLytable[angle], URxtable[angle], URytable[angle], LRxtable[angle], LRytable[angle]
        end
        if resolution and (resolution > 0) then
            angle = floor(angle/resolution+.5)*resolution
        end
		if angle >= 360 then
			angle = angle - floor(angle/360)*360
		elseif angle < 0 then
			angle = angle + ceil((abs(angle)/360))*360
		end
        if ULxtable[angle] then
            return ULxtable[angle], ULytable[angle], LLxtable[angle], LLytable[angle], URxtable[angle], URytable[angle], LRxtable[angle], LRytable[angle]
        end
		local radangle = rad(angle)
		local subtable = {}
		ULxT, ULyT = rotatepoint(X,Y,ULx,ULy,radangle)
		LLxT, LLyT = rotatepoint(X,Y,LLx,LLy,radangle)
		URxT, URyT = rotatepoint(X,Y,URx,URy,radangle)
		LRxT, LRyT = rotatepoint(X,Y,LRx,LRy,radangle)
        ULxtable[angle] = ULxT
        ULytable[angle] = ULyT
        LLxtable[angle] = LLxT
        LLytable[angle] = LLyT
        URxtable[angle] = URxT
        URytable[angle] = URyT
        LRxtable[angle] = LRxT
        LRytable[angle] = LRyT
        return ULxT, ULyT, LLxT, LLyT, URxT, URyT, LRxT, LRyT
    end
    return rotfunction
end
